#ifndef INCLUDE_WIN32FIX
#define INCLUDE_WIN32FIX


//#include <types.h>
#include <windows.h>
//#include <winuser.h>
//#include <windef.h>
#include "win32fixrc.h"

/////////////////////////////////////// _WIN32_WCE //////////////////////////////////////////
#ifndef _WIN32_WCE
typedef signed      char        INT8;
typedef unsigned    char        UINT8;
typedef signed      short       INT16;
typedef unsigned    short       UINT16;
typedef signed      int         INT32;
typedef unsigned    int         UINT32;
typedef signed      __int64     INT64;
typedef unsigned    __int64     UINT64;

typedef INT8    *PINT8;
typedef UINT8   *PUINT8;
typedef INT16   *PINT16;
typedef UINT16  *PUINT16;
typedef INT32   *PINT32;
typedef UINT32  *PUINT32;
typedef INT64   *PINT64;
typedef UINT64  *PUINT64;

inline int _inp(unsigned short x) {return 0;};
inline unsigned short _inpw(unsigned short x) {return 0;};
inline unsigned long _inpd(unsigned short x) {return 0;};
inline int _outp(unsigned short p, int x) {return x;};
inline unsigned short _outpw(unsigned short p, unsigned short x) {return x;};
inline unsigned long _outpd(unsigned short p, unsigned long x) {return x;};

inline BOOL InterruptInitialize(DWORD idInt, HANDLE hEvent, LPVOID pvData, DWORD cbData) {return TRUE;};
inline void InterruptDone(DWORD idInt) {};
inline void InterruptDisable(DWORD idInt) {};
inline void __cdecl NKDbgPrintfW(LPCTSTR Fmt, ...) 
{
   TCHAR Str[1024]; 
   va_list Arg; 
   va_start(Arg, Fmt); 
   wvsprintf(Str, Fmt, Arg); 
   va_end(Arg); 
   OutputDebugString(Str);
};

#define _ASM #error Please drop in a #ifdef _WIN32_WCE here.
#define __ASM #error Please drop in a #ifdef _WIN32_WCE here.
#define CLI _asm nop;
#define STI _asm nop;

#else

#define sprintf #error Do not use this function it is not supported by retail CE builds
#define sscanf #error Do not use this function it is not supported by retail CE builds
extern "C" int __cdecl _inp(unsigned short);
extern "C" unsigned short __cdecl _inpw(unsigned short);
extern "C" unsigned long __cdecl _inpd(unsigned short);
extern "C" int __cdecl _outp(unsigned short, int);
extern "C" unsigned short __cdecl _outpw(unsigned short, unsigned short);
extern "C" unsigned long __cdecl _outpd(unsigned short, unsigned long);
#ifndef WIN32_PLATFORM_PSPC
#pragma intrinsic(_inp, _inpw, _inpd, _outp, _outpw, _outpd)
#endif

extern "C" BOOL InterruptInitialize(DWORD idInt, HANDLE hEvent, LPVOID pvData, DWORD cbData);
extern "C" void InterruptDone(DWORD idInt);
extern "C" void InterruptDisable(DWORD idInt);
#define _ASM _asm
#define __ASM __asm
#define CLI _asm cli;
#define STI _asm sti;

inline LPTSTR lstrcpyn(LPTSTR dest, LPCTSTR source, int count)
{
   LPTSTR start = dest;
   while ((count>1) && (*dest++ = *source++))    /* copy string */
      count--;
   if (count == 1)                              /* pad with a zeroe */
      *dest++ = '\0';
   return start;
}

#endif // _WIN32_WCE

/////////////////////////////////////// UNICODE //////////////////////////////////////////
#ifdef UNICODE
#define WCSTOMBS wcstombs
#define MBSTOWCS mbstowcs
#define WCSCAT wcscat
#define WCSUPR wcsupr
#define WCSCPY wcscpy
#define WCSCMP wcscmp
#define WCSLEN wcslen
#define WCSNCPY wcsncpy
#else
inline int strlcpy(TCHAR* Dest, const TCHAR* Source, int Len)
{
   int len = strlen(Source) + 1;
   if (len > Len)
   {
      memcpy(Dest, Source, Len);
      return Len;
   }
   else
   {
      memcpy(Dest, Source, len);
      return len-1;
   };
};
#define WCSTOMBS strlcpy
#define MBSTOWCS strlcpy
#define WCSCAT strcat
#define WCSUPR _strupr
#define WCSCPY strcpy
#define WCSCMP strcmp
#define WCSLEN strlen
#define WCSNCPY lstrcpyn
#endif // UNICODE

#endif // INCLUDE_WIN32FIX

